<div class="containerAddButton">
  <button
    *ngIf="this.user.isAdmin"
    type="button"
    class="btn addButton"
    data-toggle="modal"
    (click)="myModal.show()"
  >
    Ajouter une réparation
  </button>
</div>
<div class="card">
  <div class="card-body">
    <div class="loadingTableContainer" *ngIf="isLoading || dataNotFound">
      <div class="loadingTable">
        <div class="dataNotFound" *ngIf="isLoading">
          <div style="opacity: 0.7; color: black">Chargement ...</div>
          <img
            src="assets/img/gif/cloud.gif"
            alt="this scope moves"
            width="70"
          />
        </div>
        <div class="dataNotFound" *ngIf="dataNotFound">
          <div style="color: black">Aucune donnée trouvée !</div>
          <img
            src="assets/img/gif/zoom.gif"
            alt="this scope moves"
            width="50"
          />
        </div>
      </div>
    </div>
    <!--Table here-->
    <table class="table table-striped">
      <thead style="z-index: 88" class="tableHead">
        <tr class="table-sm cc">
          <th style="min-width: 60px">
            ID
            <input
              *ngIf="filterId"
              class="inputFilter"
              style="width: 50px"
              type="text"
              [(ngModel)]="filters[0]['id']"
              (keyup)="getSiteTypes(1)"
            />
            <i
              class="fa fa-filter fa-lg customfilter"
              (click)="filterId = !filterId"
            ></i>
          </th>
          <th style="min-width: 10px">
            ID Elément
            <input
              *ngIf="filterElement"
              class="inputFilter"
              type="text"
              [(ngModel)]="filters[8]['element']"
              (keyup)="getSiteTypes(1)"
            />
            <i
              class="fa fa-filter fa-lg customfilter"
              (click)="filterElement = !filterElement"
            ></i>
          </th>
          <th style="min-width: 200px">
            fournisseur de services
            <input
              *ngIf="filterFournisseur"
              class="inputFilter"
              type="text"
              [(ngModel)]="filters[3]['service_provider']"
              (keyup)="getSiteTypes(1)"
            />
            <i
              class="fa fa-filter fa-lg customfilter"
              (click)="filterFournisseur = !filterFournisseur"
            ></i>
          </th>

          <th style="min-width: 130px">
            Commentaire
            <input
              *ngIf="filterComment"
              class="inputFilter"
              type="text"
              [(ngModel)]="filters[4]['comment']"
              (keyup)="getSiteTypes(1)"
            />
            <i
              class="fa fa-filter fa-lg customfilter"
              (click)="filterComment = !filterComment"
            ></i>
          </th>

          <th style="min-width: 88px" *ngIf="this.user.isAdmin">
            Sinistre
            <div *ngIf="filterSinistre" class="col-form-label inputFilterActif">
              <div class="form-check">
                <input
                  class="form-check-input"
                  type="radio"
                  name="radios"
                  id="radio1"
                  value=""
                  [(ngModel)]="filters[5]['sinister']"
                  (change)="getSiteTypes(1)"
                  checked=""
                />
                <label for="radio1" class="form-check-label"> ALL </label>
              </div>
              <div class="form-check">
                <input
                  class="form-check-input"
                  type="radio"
                  name="radios"
                  id="radio2"
                  value="true"
                  [(ngModel)]="filters[5]['sinister']"
                  (change)="getSiteTypes(1)"
                />
                <label for="radio2" class="form-check-label"> Active </label>
              </div>
              <div class="form-check">
                <input
                  class="form-check-input"
                  type="radio"
                  name="radios"
                  id="radio3"
                  value="false"
                  [(ngModel)]="filters[5]['sinister']"
                  (change)="getSiteTypes(1)"
                />
                <label for="radio3" class="form-check-label"> Inactive </label>
              </div>
            </div>
            <i
              class="fa fa-filter fa-lg customfilter"
              (click)="filterSinistre = !filterSinistre"
            ></i>
          </th>

          <th style="min-width: 70px">
            Montant
            <input
              *ngIf="filterAmount"
              class="inputFilter"
              type="text"
              [(ngModel)]="filters[6]['amount%5Bgte%5D']"
              (keyup)="getSiteTypes(1)"
            />
            <i
              class="fa fa-filter fa-lg customfilter"
              (click)="filterAmount = !filterAmount"
            ></i>
          </th>

          <th style="min-width: 10px">
            Type de réparation
            <input
              *ngIf="filterReparationType"
              class="inputFilter"
              type="text"
              [(ngModel)]="filters[7]['reparation_type']"
              (keyup)="getSiteTypes(1)"
            />
            <i
              class="fa fa-filter fa-lg customfilter"
              (click)="filterReparationType = !filterReparationType"
            ></i>
          </th>
          <th style="min-width: 180px">Date d'envoi de la réparation</th>
          <th style="min-width: 220px">Date de fin de réparation</th>

          <th *ngIf="this.user.isAdmin" style="width: 80px; padding: 15px 0px">
            Actions
          </th>
        </tr>
      </thead>
      <tbody>
        <tr *ngFor="let siteType of siteTypes">
          <td>{{ siteType.id }}</td>
          <td>
            <div style="margin-left: 20px">{{ siteType.element.id }}</div>
          </td>
          <td>{{ siteType.service_provider }}</td>
          <td>{{ siteType.comment }}</td>
          <td *ngIf="this.user.isAdmin">
            <label class="switch switch-label switch-pill switch-success">
              <input
                type="checkbox"
                [(ngModel)]="siteType.sinister"
                (click)="changeStatut(siteType.id, siteType.sinister)"
                class="switch-input"
              />
              <span
                data-checked="✓"
                data-unchecked="✕"
                class="switch-slider"
              ></span>
            </label>
          </td>
          <td>{{ siteType.amount }}</td>
          <td>{{ siteType.reparation_type.name }}</td>
          <td>
            <div style="margin-left: 55px">
              {{ siteType.reparation_sending_date | date: "MMM d, y" }}
            </div>
          </td>
          <td>
            <div style="margin-left: 55px">
              {{ siteType.reparation_end_date | date: "MMM d, y" }}
            </div>
          </td>
          <td style="z-index: 2222" *ngIf="this.user.isAdmin">
            <div class="editIcon">
              <i
                class="icon-note icons font-2xl"
                (click)="showUpdateModal(siteType); myUpdateModal.show()"
              ></i>
            </div>
          </td>
        </tr>
      </tbody>
    </table>
  </div>
  <div class="count">
    <div>Résultats {{ siteTypes.length }} (filtrés parmi {{ totalCount }})</div>
  </div>
</div>
<div class="pages" *ngIf="totalCount > 4">
  <ul class="pagination">
    <li class="page-item" (click)="getSiteTypes(pagination.first)">
      <a class="page-link"><i class="fa fa-angle-double-left fa-lg"></i></a>
    </li>

    <li class="page-item" (click)="getSiteTypes(pagination.prev)">
      <a class="page-link" *ngIf="pagination.first < pagination.current"
        ><i class="fa fa-angle-left fa-lg"></i
      ></a>
    </li>
    <li class="page-item" (click)="getSiteTypes(pagination.prev - 1)">
      <a class="page-link" *ngIf="pagination.first < pagination.prev">..</a>
    </li>
    <li class="page-item" (click)="getSiteTypes(pagination.prev)">
      <a class="page-link" *ngIf="pagination.prev < pagination.current">{{
        pagination.prev
      }}</a>
    </li>
    <li class="page-item active" (click)="getSiteTypes(pagination.current)">
      <a class="page-link">{{ pagination.current }}</a>
    </li>
    <li class="page-item" (click)="getSiteTypes(pagination.next)">
      <a class="page-link" *ngIf="pagination.next > pagination.current">{{
        pagination.next
      }}</a>
    </li>
    <li class="page-item">
      <a
        class="page-link"
        (click)="getSiteTypes(pagination.next + 1)"
        *ngIf="pagination.next < pagination.last"
        >..</a
      >
    </li>
    <li class="page-item" (click)="getSiteTypes(pagination.next)">
      <a class="page-link" *ngIf="pagination.current != pagination.last"
        ><i class="fa fa-angle-right fa-lg"></i
      ></a>
    </li>
    <li class="page-item" (click)="getSiteTypes(pagination.last)">
      <a class="page-link"><i class="fa fa-angle-double-right fa-lg"></i></a>
    </li>
  </ul>
</div>
<!--Add window !!!-->
<!--Add window !!!-->
<!--Add window !!!-->
<!--Add window !!!-->
<div
  bsModal
  #myModal="bs-modal"
  class="modal fade"
  tabindex="-1"
  role="dialog"
  aria-labelledby="myModalLabel"
  aria-hidden="false"
>
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h4 class="modal-title">Ajouter une réparation</h4>
        <button
          type="button"
          class="close"
          (click)="myModal.hide(); resetAddModal()"
          aria-label="Close"
        >
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div role="alert" class="alert alert-success" *ngIf="successAddSiteType">
        Une nouvelle réparation est ajoutée<strong> avec succès.</strong>
      </div>
      <div role="alert" class="alert alert-danger" *ngIf="errorAddSiteType">
        <strong>Oops ! </strong> Modifiez quelques éléments et essayez de
        soumettre de nouveau !
      </div>
      <div class="modal-body">
        <div class="form-group custom-col">
          <label>Element</label>
          <select
            style="color: black"
            class="form-control"
            [(ngModel)]="newtSiteType.element"
          >
            <option selected disabled value="">
              Choisir l'id de l'élément
            </option>
            <option *ngFor="let element of elements" [ngValue]="element['@id']">
              {{ element["id"] }}
            </option>
          </select>
          <div class="custom-col">
            <span *ngIf="emptyPickElement">
              * Veuillez sélectionner une option pour continuer
            </span>
          </div>
        </div>
        <div class="form-group custom-col">
          <label>fournisseur de services </label>
          <input
            (keyup)="CheckEmpty()"
            (blur)="CheckEmpty()"
            type="text"
            placeholder="Nom de type.."
            class="form-control"
            [(ngModel)]="newtSiteType.serviceProvider"
            style="color: black"
            [ngStyle]="inputStyle"
          />
          <span *ngIf="isEmpty"> * Ce champ est obligatoire ! </span>
        </div>
        <div class="form-group custom-col">
          <label>Commentaire</label>
          <input
            (keyup)="CheckEmpty3()"
            (blur)="CheckEmpty3()"
            type="text"
            placeholder="commentaire.."
            class="form-control"
            [(ngModel)]="newtSiteType.comment"
            style="color: black"
            [ngStyle]="inputStyle3"
          />
          <span *ngIf="isEmpty3"> * Ce champ est obligatoire ! </span>
        </div>
        <div class="form-group custom-col">
          <label>Montant</label>
          <input
            (keyup)="CheckEmpty2()"
            (blur)="CheckEmpty2()"
            type="number"
            placeholder="montant.."
            class="form-control"
            [(ngModel)]="newtSiteType.amount"
            style="color: black"
            [ngStyle]="inputStyle2"
          />
          <span *ngIf="isEmpty2"> * Ce champ est obligatoire ! </span>
        </div>
        <div class="form-group custom-col">
          <label>Date d'envoi de la réparation</label>
          <input
            type="date"
            class="form-control"
            [(ngModel)]="newtSiteType.reparationSendingDate"
            style="color: black"
          />
          <div class="errorMessage">
            <span *ngIf="emptyDateReparationSendingDate">
              * Veuillez sélectionner une date pour continuer
            </span>
          </div>
        </div>
        <div class="form-group custom-col">
          <label>Date de fin de réparation</label>
          <input
            type="date"
            class="form-control"
            [(ngModel)]="newtSiteType.reparationEndDate"
            style="color: black"
          />
          <div class="errorMessage">
            <span *ngIf="emptyDateReparationEndDate">
              * Veuillez sélectionner une date pour continuer
            </span>
          </div>
        </div>
        <div class="form-group custom-col">
          <label>Type de répération</label>
          <select
            style="color: black"
            class="form-control"
            [(ngModel)]="newtSiteType.reparationType"
          >
            <option selected disabled value="">
              Choisir un type de réparation
            </option>
            <option
              *ngFor="let repatationType of reparationTypes"
              [ngValue]="repatationType['@id']"
            >
              {{ repatationType["name"] }}
            </option>
          </select>
          <div class="custom-col">
            <span *ngIf="emptyPickReparationType">
              * Veuillez sélectionner une option pour continuer
            </span>
          </div>
        </div>
        <div class="selectActif">
          <label>Sinistre </label>
          <div class="selectBox">
            <label class="switch switch-label switch-pill switch-success">
              <input
                type="checkbox"
                [(ngModel)]="newtSiteType.sinister"
                class="switch-input"
              />
              <span
                data-checked="✓"
                data-unchecked="✕"
                class="switch-slider"
              ></span>
            </label>
          </div>
        </div>
      </div>
      <div class="modal-footer">
        <button
          type="button"
          class="btn btn-secondary"
          (click)="myModal.hide(); resetAddModal()"
        >
          Annuler
        </button>
        <button
          type="button"
          class="btn addButton"
          (click)="addNewSiteType(); uniquenessCheck(); checkNoEmptyFields()"
        >
          Ajouter
        </button>
      </div>
    </div>
    <!-- /.modal-content -->
  </div>
  <!-- /.modal-dialog -->
</div>
<!-- /.modal -->

<!-- Update Window !!! -->
<!-- Update Window !!! -->
<!-- Update Window !!! -->

<div
  bsModal
  #myUpdateModal="bs-modal"
  class="modal fade"
  tabindex="-1"
  role="dialog"
  aria-labelledby="myModalLabel"
  aria-hidden="false"
>
  <div class="modal-dialog" role="document">
    <div class="modal-content">
      <div class="modal-header">
        <h4 class="modal-title">Modifier cette réparation</h4>
        <button
          type="button"
          class="close"
          (click)="myUpdateModal.hide(); resetAddModal()"
          aria-label="Close"
        >
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <!--Alert messages here-->
      <div
        class="alert alert-success alert-dismissible fade show"
        role="alert"
        style="
          max-width: 95%;
          margin-left: 10px;
          margin-top: 10px;
          margin-bottom: -8px;
        "
        *ngIf="successModifySiteType"
      >
        Les modifications ont été opérées avec<strong> succès !</strong>
        <button
          type="button"
          class="btn-close"
          data-bs-dismiss="alert"
          aria-label="Close"
        ></button>
      </div>

      <div
        class="alert alert-danger alert-dismissible fade show"
        role="alert"
        style="
          max-width: 95%;
          margin-left: 10px;
          margin-top: 10px;
          margin-bottom: -8px;
        "
        *ngIf="failModifySiteType"
      >
        <strong>Oops ! </strong> Modifiez quelques éléments et essayez de
        soumettre de nouveau !
        <button
          type="button"
          class="btn-close"
          data-bs-dismiss="alert"
          aria-label="Close"
        ></button>
      </div>

      <div class="modal-body">
        <div class="form-group custom-col">
          <label>Element</label>
          <select
            style="color: black"
            class="form-control"
            [(ngModel)]="updateSiteType.element"
          >
            <option selected disabled value="">
              Choisir l'Id de l'élément
            </option>
            <option *ngFor="let element of elements" [ngValue]="element['@id']">
              {{ element["id"] }}
            </option>
          </select>
          <div class="custom-col">
            <span *ngIf="emptyPick">
              * Veuillez sélectionner une option pour continuer
            </span>
          </div>
        </div>
        <div class="form-group custom-col">
          <label>fournisseur de services </label>
          <input
            (blur)="CheckEmptyEdit()"
            (keyup)="CheckEmptyEdit()"
            type="text"
            placeholder="Nom de type.."
            class="form-control"
            [(ngModel)]="updateSiteType.serviceProvider"
            style="color: black"
            [ngStyle]="inputStyle"
          />
          <span *ngIf="!updateSiteType.serviceProvider">
            * Ce champ est obligatoire !
          </span>
        </div>
        <div class="form-group custom-col">
          <label>Commentaire</label>
          <input
            (blur)="CheckEmpty3Edit()"
            (keyup)="CheckEmpty3Edit()"
            type="text"
            placeholder="Nom de type.."
            class="form-control"
            [(ngModel)]="updateSiteType.comment"
            style="color: black"
          />
          <span *ngIf="!updateSiteType.comment">
            * Ce champ est obligatoire !
          </span>
        </div>
        <div class="form-group custom-col">
          <label>Montant</label>
          <input
            (blur)="CheckEmpty2Edit()"
            (keyup)="CheckEmpty2Edit()"
            type="number"
            placeholder="Nom de type.."
            class="form-control"
            [(ngModel)]="updateSiteType.amount"
            style="color: black"
          />
          <span *ngIf="!updateSiteType.amount">
            * Ce champ est obligatoire !
          </span>
        </div>
        <div class="form-group custom-col">
          <label>Date d'envoi de la réparation</label>
          <input
            type="date"
            placeholder="Nom de type.."
            class="form-control"
            [(ngModel)]="updateSiteType.reparationSendingDate"
            style="color: black"
          />
        </div>
        <div class="form-group custom-col">
          <label>Date de fin de réparation</label>
          <input
            type="date"
            placeholder="Nom de type.."
            class="form-control"
            [(ngModel)]="updateSiteType.reparationEndDate"
            style="color: black"
          />
        </div>
        <div class="form-group custom-col">
          <label>Type de répération</label>
          <select
            style="color: black"
            class="form-control"
            [(ngModel)]="updateSiteType.reparationType"
          >
            <option selected disabled value="">
              Choisir un type de réparation
            </option>
            <option
              *ngFor="let repatationType of reparationTypes"
              [ngValue]="repatationType['@id']"
            >
              {{ repatationType["name"] }}
            </option>
          </select>
          <div class="custom-col">
            <span *ngIf="emptyPick">
              * Veuillez sélectionner une option pour continuer
            </span>
          </div>
        </div>
        <div class="selectActif">
          <label>Sinistre</label>
          <div class="selectBox">
            <label class="switch switch-label switch-pill switch-success">
              <input
                type="checkbox"
                [(ngModel)]="updateSiteType.sinister"
                class="switch-input"
              />
              <span
                data-checked="✓"
                data-unchecked="✕"
                class="switch-slider"
              ></span>
            </label>
          </div>
        </div>
      </div>
      <div class="modal-footer">
        <button
          type="button"
          class="btn btn-secondary"
          (click)="myUpdateModal.hide()"
        >
          Annuler
        </button>
        <button
          name="submit"
          type="button"
          class="btn btn-success"
          (click)="putSiteType()"
        >
          Enregistrer
        </button>
      </div>
    </div>
  </div>
</div>
